'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = contextReplacementPlugin;

var _webpack = require('webpack');

function contextReplacementPlugin(context, matcher) {
  var recursive = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  // use ContextReplacementPlugin to replace the initial context with a
  // new regExp to match the desired files
  return new _webpack.ContextReplacementPlugin(new RegExp(context), function (result) {
    if (result.request === context) {
      // provide a new test function for resolving
      result.regExp = { test: matcher }; // eslint-disable-line no-param-reassign
      result.recursive = recursive; // eslint-disable-line no-param-reassign
    }
  });
}
module.exports = exports['default'];