"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = prepareEntry;
function prepareEntry(path) {
  var watch = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

  if (watch) {
    return "\n    // This gets replaced by webpack with the updated files on rebuild\n    var __webpackManifest__ = [];\n\n    var testsContext = require.context(\"" + path + "\", false);\n\n    function inManifest(path) {\n      return __webpackManifest__.indexOf(path) >= 0;\n    }\n\n    var runnable = testsContext.keys().filter(inManifest);\n\n    runnable.forEach(testsContext);\n    ";
  }
  return "\n    var testsContext = require.context(\"" + path + "\", false);\n\n    var runnable = testsContext.keys();\n\n    runnable.forEach(testsContext);\n    ";
}
module.exports = exports['default'];